routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Auth::routes();

Route::get('/', 'HomeController@index')->name('home');
Route::get('/portal/dashboard', 'HomeController@dashboard')->name('dashboard');
Route::resource('category', 'Admin\CategoryController');
Route::resource('item', 'Admin\ItemController');
Route::resource('user', 'Admin\UserController');
Route::get('get-item-size-price/{id}', 'Admin\ItemController@loadItemExtraPrice')->name('loadItemExtraPrice');
Route::post('item-size-price', 'Admin\ItemController@addExtraPriceItem')->name('addExtraPriceItem');

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use URL;
class Category extends Model
{

	public function subcategory(){
        return $this->hasMany('App\Models\Category', 'parent_id');
    }

    public function items(){
        return $this->hasMany('App\Models\Item','category_id');
    }

	public function setTitleAttribute($value)
    {
        $this->attributes['title'] = ucwords($value);
    }

    public function processImage() {
		if ($this->featuredImage) {
			return URL::asset($this->featuredImage);
		} else {
			return null;
		}
	}
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Category;
use Validator;
use Session;

class CategoryController extends BaseController
{
    protected $imageDestination;

    public function __construct() {
        $this->imageDestination = 'uploads/images/category';
    }


    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data['panel'] = 'List of Categories';
        $data['rows'] = Category::where('status',1)->get();
        return view('admin.category.index',compact('data')); 
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $data['panel'] = 'Add Category';
        $data['categories'] = json_encode(Category::where('status',1)->select('id','title')->pluck('title','id')->toArray());
        return view('admin.category.create',compact('data')); 
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validatedData = $request->validate([
            'parentCategory' => '',
            'categoryTitle' => 'required',
            'file' => '',
            'description' => 'min:6',
            'status' => 'required|in:0,1',
        ]);

        try {
            // dd($request->all());

            /* Image Process */
            $image_name = '';

            // sanitize request

            if ($request->hasFile('file')) {
                $file = $request->file('file');
                $imageName = $request->get('categoryTitle');
                $path = $this->imageDestination;
                $returnedImage = $this->saveUpdateImage($file, $imageName, $path);
                $image_name = $returnedImage;
            }else {
                $image_name = null;
            }

            $category = new Category();
            $category->title = $request->categoryTitle;
            $category->parent_id = ($request->parentCategory == '' || $request->parentCategory == null )? 0:$request->parentCategory;
            $category->status = $request->status;
            $category->content = $request->description;
            $category->featuredImage = $image_name;

            if ($category->save()) {
                Session::flash('success_message', 'Category has been Added.');
                return redirect('category')->with('success_message', 'Category added Successfully.');
            } else {
                Session::flash('error_message', 'Category could not be add.');
                return redirect('category')->with('error_message', 'Category could not be added.');
            }

        } catch (Exception $e) {
            Session::flash('error_message', 'Category could not be add.');
            return redirect('category')->with('error_message', 'Category could not be added.');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data['panel'] = 'Edit Category';
        $data['row'] = Category::find($id);
        $data['categories'] = json_encode(Category::where('status',1)->select('id','title')->pluck('title','id')->toArray());
        return view('admin.category.edit',compact('data')); 
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        
        
        $validatedData = $request->validate([
            'parentCategory' => '',
            'categoryTitle' => 'required',
            'file' => '',
            'description' => 'min:6',
            'status' => 'required|in:0,1',
        ]);

        try {

            $category = Category::find($id);

            /* Image Process */
            $image_name = '';

            // sanitize request

            if ($request->hasFile('file')) {
                $file = $request->file('file');
                $imageName = $request->get('categoryTitle');
                $path = $this->imageDestination;
                $returnedImage = $this->saveUpdateImage($file, $imageName, $path);
                $image_name = $returnedImage;
                
                if ($category->featuredImage) {
                    $old_img = $category->featuredImage;
                    if (file_exists($old_img)) {
                        unlink($old_img);
                    }
                }
            } elseif (isset($category->featuredImage) && !empty($category->featuredImage)) {
                $image_name = $category->featuredImage;
            }

            $category->title = $request->categoryTitle;
            $category->parent_id = ($request->parentCategory == '' || $request->parentCategory == null )? 0:$request->parentCategory;
            $category->status = $request->status;
            $category->content = $request->description;
            $category->featuredImage = $image_name;

            if ($category->save()) {
                Session::flash('success_message', 'Category has been Added.');
                return redirect('category')->with('success_message', 'Category added Successfully.');
            } else {
                Session::flash('error_message', 'Category could not be add.');
                return redirect('category')->with('error_message', 'Category could not be added.');
            }

        } catch (Exception $e) {
            Session::flash('error_message', 'Category could not be add.');
            return redirect('category')->with('error_message', 'Category could not be added.');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Api/CategoryController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\Item;
use Validator;

class CategoryController extends Controller
{
    public function getCategoryLists(){
    	$data['categories'] = Category::where('status',1)->get();
    	$data['total'] = count($data['categories']);
		
		return response()->json(
		[
		    'status'=>'success',
		    'error'=>false,
		    'data'=> $data['categories']
		],200);
		
    }
    public function getCategoryItemLists(Request $request){

    	$validator = Validator::make($request->all(), [
                'category_id' => 'required|integer',
            ]);

        if($validator->fails()){
            \Log::log('info',"'Cart item delete request: ".json_encode($validator->errors()->toJson())."'");
            return response()->json(
                [
                    'status'=> 'error',
                    'error'        =>  true,
                    'error_msg'=>$validator->errors()->toJson()
                ], 400);
        }


    	$category = Category::where([['id',$request->category_id],['status',1]])->first();


    	if($category){	

    		return response()->json(
			[
				    'status'=>'success',
				    'error'=>false,
				    'data'=> $category->items()->with('itemOtherPrice')->where('status',1)->get(),
			],200);

    	}else{
	    	return response()->json(
			[
			    'status'=>'error',
			    'error'=>true,
			    'message'=> 'No Category Found.'
			],400);
    	}

		
    }
}

resources/views/admin/category/create.blade.php
@extends('admin.layouts.master')

@section('content')
<h1 class="h3 mb-4 text-gray-800">{{ $data['panel'] }}</h1>
<div class="row">
    <div class="col-8">
        <div class="card shadow mb-4">
            <!-- Card Header - Accordion -->
            <a href="#collapseForm" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseForm">
              <h6 class="m-0 font-weight-bold text-primary">Add Category</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseForm">
              <div class="card-body">
                <form id="categoryForm" method="post" action="{{ route('category.store') }}" enctype="multipart/form-data">
                    @csrf
                    @include('admin.category.form')
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
              </div>
            </div>
        </div>
    </div>
</div>

@endsection

@section('styles')
<link rel="stylesheet" type="text/css" href="{{ asset('assets/backend/vendor/summernote/summernote-bs4.css') }}">
@endsection

@section('scripts')
<script type="text/javascript" src="{{ asset('assets/backend/vendor/summernote/summernote-bs4.min.js') }}"></script>
<script type="text/javascript">
    $(document).ready(function() {
      $('#summernote').summernote({
        height: 150,
      });
    });
</script>
@endsection

resources/views/admin/category/edit.blade.php
@extends('admin.layouts.master')

@section('content')
<h1 class="h3 mb-4 text-gray-800">{{ $data['panel'] }}</h1>
<div class="row">
    <div class="col-8">
        <div class="card shadow mb-4">
            <!-- Card Header - Accordion -->
            <a href="#collapseForm" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseForm">
              <h6 class="m-0 font-weight-bold text-primary">Edit Category</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseForm">
              <div class="card-body">
                <form id="categoryForm" method="POST" action="{{ route('category.update', ['id' => $data['row']->id]) }}" accept-charset="UTF-8" enctype="multipart/form-data">
                    <input type="hidden" name="_method" value="PUT">
                    @csrf
                    @include('admin.category.form')
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
              </div>
            </div>
        </div>
    </div>
    <div class="col-4">
        @if(isset($data['row']))
            <img src="{{ $data['row']->processImage()}}" width="100%" height="250px">
        @endif
    </div>
</div>

@endsection

@section('styles')
<link rel="stylesheet" type="text/css" href="{{ asset('assets/backend/vendor/summernote/summernote-bs4.css') }}">
@endsection

@section('scripts')
<script type="text/javascript" src="{{ asset('assets/backend/vendor/summernote/summernote-bs4.min.js') }}"></script>
<script type="text/javascript">
    $(document).ready(function() {
      $('#summernote').summernote({
        height: 150,
      });
    });
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.0/jquery.validate.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.0/additional-methods.min.js"></script>
@endsection

resources/views/admin/category/form.blade.php
<div class="form-group">
    <label for="">Choose Parent Category</label>
    <select name="parentCategory" class="form-control" id="parentCategory">
        <option value="">Please Choose</option>
            @foreach (json_decode($data["categories"], true) as $optionKey => $optionValue)
                <option value="{{ $optionKey }}" {{ (isset($data['row']->parent_id) && $data['row']->parent_id == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
            @endforeach
    </select>
    <span class="text-danger">{{ $errors->first('parentCategory') }}</span>
</div>

<div class="form-group">
    <label for="">Category Title</label>
    <input type="text" class="form-control" id="categoryTitle" name="categoryTitle" placeholder="Enter Category Title" autocomplete="off" value="{{ old('categoryTitle')?? (isset($data['row'])? $data['row']->title:'')  }}">
    <span class="text-danger">{{ $errors->first('categoryTitle') }}</span>
</div>

<div class="form-group">
    <label for="">Category Featured Image</label>
    <input id="fileupload" type="file" name="file" data-folder="category">
    <span class="text-danger">{{ $errors->first('file') }}</span>
</div>

<div class="form-group">
    <label for="">Category Title</label>
    <textarea class="form-control" id="summernote" name="description" autocomplete="off">
        {{ old('description')?? (isset($data['row'])? $data['row']->content:'') }}
    </textarea>
    <span class="text-danger">{{ $errors->first('description') }}</span>

</div>

<div class="form-group">
    <label for="">Status</label>
    <select name="status" class="form-control" id="status" >
        @foreach (json_decode('{"1": "Published", "0": "Not Published"}', true) as $optionKey => $optionValue)
            <option value="{{ $optionKey }}" {{ (isset($data['row']->status) && $data['row']->status == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
        @endforeach
    </select>
    <span class="text-danger">{{ $errors->first('status') }}</span>

</div>

resources/views/admin/category/index.blade.php
@extends('admin.layouts.master')

@section('content')
<h1 class="h3 mb-4 text-gray-800">{{ $data['panel'] }}</h1>
<div class="row">
    <div class="col-4">
        <div class="card shadow mb-4">
            <!-- Card Header - Accordion -->
            <a href="#collapseForm" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseForm">
              <h6 class="m-0 font-weight-bold text-primary">Add Category</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseForm">
              <div class="card-body">
                <form id="categoryForm" method="post" action="javascript:void(0)">
                  @csrf
                    <div class="form-group">
                        <label for="">Choose Parent Category</label>
                        <select name="parentCategory" class="form-control" id="parentCategory">
                            <option value="">Please Choose</option>
                        </select>
                        <span class="text-danger">{{ $errors->first('parentCategory') }}</span>
                    </div>

                    <div class="form-group">
                        <label for="">Category Title</label>
                        <input type="text" class="form-control" id="categoryTitle" placeholder="Enter Category Title">
                        <span class="text-danger">{{ $errors->first('categoryTitle') }}</span>
                    </div>

                    <div class="form-group">
                        <label for="">Category Title</label>
                        <input id="fileupload" type="file" name="file" data-folder="category">
                        <span class="text-danger">{{ $errors->first('file') }}</span>
                    </div>

                    <div class="form-group">
                        <label for="">Category Title</label>
                        <textarea class="form-control" id="summernote" name="description">
                        </textarea>
                        <span class="text-danger">{{ $errors->first('description') }}</span>

                    </div>

                    <div class="form-group">
                        <label for="">Status</label>
                        <select name="status" class="form-control" id="status" >
                            @foreach (json_decode('{"1": "Published", "0": "Not Published"}', true) as $optionKey => $optionValue)
                                <option value="{{ $optionKey }}" {{ (isset($data['row']->status) && $data['row']->status == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
                            @endforeach
                        </select>
                        <span class="text-danger">{{ $errors->first('status') }}</span>

                    </div>

                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
              </div>
            </div>
        </div>
    </div>

    <div class="col-8">
        <div class="card shadow mb-4">
            
            <!-- Card Header - Accordion -->
            <a href="#collapseCardExample" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseCardExample">
              <h6 class="m-0 font-weight-bold text-primary">Collapsable Card Example</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseCardExample">
              <div class="card-body">
                This is a collapsable card example using Bootstrap's built in collapse functionality. <strong>Click on the card header</strong> to see the card body collapse and expand!
              </div>
            </div>

        </div>
    </div>
</div>

@endsection

@section('styles')
<link rel="stylesheet" type="text/css" href="{{ asset('assets/backend/vendor/summernote/summernote-bs4.css') }}">
@endsection

@section('scripts')
<script type="text/javascript" src="{{ asset('assets/backend/vendor/summernote/summernote-bs4.min.js') }}"></script>
<script type="text/javascript">
    $(document).ready(function() {
      $('#summernote').summernote({
        height: 150,
      });
    });
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.0/jquery.validate.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.0/additional-methods.min.js"></script>
@endsection